#!/bin/sh
-. git-sh-setup || dir "Not a git archive"
+. git-sh-setup
usage() {
echo >&2 'usage: git bisect [start|bad|good|next|reset|visualize]
git bisect good [<rev>...] mark <rev>... known-good revisions.
git bisect next find next bisection to test and check it out.
git bisect reset [<branch>] finish bisection search and go back to branch.
-git bisect visualize show bisect status in gitk.'
+git bisect visualize show bisect status in gitk.
+git bisect replay <logfile> replay bisection log
+git bisect log show bisect log.'
exit 1
}
# Verify HEAD. If we were bisecting before this, reset to the
# top-of-line master first!
#
- head=$(readlink $GIT_DIR/HEAD) || die "Bad HEAD - I need a symlink"
+ head=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD) ||
+ die "Bad HEAD - I need a symbolic ref"
case "$head" in
refs/heads/bisect*)
git checkout master || exit
refs/heads/*)
;;
*)
- die "Bad HEAD - strange symlink"
+ die "Bad HEAD - strange symbolic ref"
;;
esac
rm -f "$GIT_DIR/refs/heads/bisect"
rm -rf "$GIT_DIR/refs/bisect/"
mkdir "$GIT_DIR/refs/bisect"
+ echo "git-bisect start" >"$GIT_DIR/BISECT_LOG"
}
bisect_bad() {
*)
usage ;;
esac || exit
- echo "$rev" > "$GIT_DIR/refs/bisect/bad"
+ echo "$rev" >"$GIT_DIR/refs/bisect/bad"
+ echo "# bad: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
+ echo "git-bisect bad $rev" >>"$GIT_DIR/BISECT_LOG"
bisect_auto_next
}
do
rev=$(git-rev-parse --verify "$rev") || exit
echo "$rev" >"$GIT_DIR/refs/bisect/good-$rev"
+ echo "# good: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
+ echo "git-bisect good $rev" >>"$GIT_DIR/BISECT_LOG"
done
bisect_auto_next
}
}
bisect_auto_next() {
- bisect_next_check && bisect_next
+ bisect_next_check && bisect_next || :
}
bisect_next() {
echo "$rev" > "$GIT_DIR/refs/heads/new-bisect"
git checkout new-bisect || exit
mv "$GIT_DIR/refs/heads/new-bisect" "$GIT_DIR/refs/heads/bisect" &&
- ln -sf refs/heads/bisect "$GIT_DIR/HEAD"
+ GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD refs/heads/bisect
+ git-show-branch "$rev"
}
bisect_visualize() {
esac
git checkout "$branch" &&
rm -fr "$GIT_DIR/refs/bisect"
- rm -f "$GIT_DIR/refs/reads/bisect"
+ rm -f "$GIT_DIR/refs/heads/bisect"
+ rm -f "$GIT_DIR/BISECT_LOG"
+}
+
+bisect_replay () {
+ test -r "$1" || {
+ echo >&2 "cannot read $1 for replaying"
+ exit 1
+ }
+ bisect_reset
+ while read bisect command rev
+ do
+ test "$bisect" = "git-bisect" || continue
+ case "$command" in
+ start)
+ bisect_start
+ ;;
+ good)
+ echo "$rev" >"$GIT_DIR/refs/bisect/good-$rev"
+ echo "# good: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
+ echo "git-bisect good $rev" >>"$GIT_DIR/BISECT_LOG"
+ ;;
+ bad)
+ echo "$rev" >"$GIT_DIR/refs/bisect/bad"
+ echo "# bad: "$(git-show-branch $rev) >>"$GIT_DIR/BISECT_LOG"
+ echo "git-bisect bad $rev" >>"$GIT_DIR/BISECT_LOG"
+ ;;
+ *)
+ echo >&2 "?? what are you talking about?"
+ exit 1 ;;
+ esac
+ done <"$1"
+ bisect_auto_next
}
case "$#" in
bisect_visualize "$@" ;;
reset)
bisect_reset "$@" ;;
+ replay)
+ bisect_replay "$@" ;;
+ log)
+ cat "$GIT_DIR/BISECT_LOG" ;;
*)
usage ;;
esac